Package org.pushingpixels.substance.internal.contrib.xoetrope.editor.color

# Class ColorWheelPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
javax.swing.colorchooser.AbstractColorChooserPanel
org.pushingpixels.substance.internal.contrib.xoetrope.editor.color.ColorWheelPanel

All Implemented Interfaces:
  `ActionListener`, `MouseListener`, `MouseMotionListener`, `MouseWheelListener`, `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `ChangeListener`

public class ColorWheelPanel extends AbstractColorChooserPanel implements ActionListener, MouseListener, MouseMotionListener, MouseWheelListener, ChangeListener
A color wheel showing a Red, Yellow, Blue color model traditionally used by graphic artists. $Revision: 2254 $

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JPanel

`JPanel.AccessibleJPanel`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ALWAYS_ADJUST`
`static final int`
`ANALOGIC_SCHEME`
`protected JTextField`
`baseColorEdit`
`protected JLabel`
`baseColorLabel`
`protected Ellipse2D`
`borderCircle`
`protected JTextField`
`brightEdit`
`protected JSlider`
`brightnessSlider`
`protected ModelColor`
`chooserColor`
`static final int`
`CONTRASTING_SCHEME`
`static final int`
`CTRL_ADJUST`
`protected JCheckBox`
`decimalRGB`
`static final int`
`DOUBLE_CONTRAST_SCHEME`
`protected JPanel`
`fixedPanel`
`protected Font`
`font9pt`
`protected JTextField`
`hueEdit`
`protected org.pushingpixels.substance.internal.contrib.xoetrope.editor.color.ColorWheelPanel.ColorWheel`
`imagePicker`
`protected Ellipse2D`
`innerCircle`
`static final int`
`MONOCHROMATIC_SCHEME`
`static final int`
`NEVER_ADJUST`
`protected Ellipse2D`
`outerCircle`
`protected BufferedImage`
`pickerImage`
`protected JButton`
`resetBtn`
`protected JTextField`
`satEdit`
`protected JSlider`
`saturationSlider`
`protected ModelColor[]`
`selectedIttenColours`
`static final int`
`SOFT_CONTRAST_SCHEME`
`protected JCheckBox`
`useWebColors`

### Fields inherited from class javax.swing.colorchooser.AbstractColorChooserPanel

`TRANSPARENCY_ENABLED_PROPERTY`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`ColorWheelPanel()`
Creates a new instance of ColorWheelPanel

## Method Summary

Modifier and Type
Method
Description
`void`
`actionPerformed(ActionEvent e)`
Respond to action events for the edit fields
`void`
`addChangeListener(ChangeListener l)`
Add a listener for changes in the selected color
`protected void`
`buildChooser()`
`int`
`getAdjustWheel()`
Get the adjust color wheel flag.
`int`
`getBrightness()`
Get the selected colors brightness
`ModelColor`
`getChooserColour()`
Get the chooser color
`Color`
`getColor()`
Get the selected color
`String`
`getDisplayName()`
`int`
`getHue()`
Get the selected colors hue
`Icon`
`getLargeDisplayIcon()`
`Dimension`
`getPreferredSize()`
`boolean`
`getRollover()`
Get the adjust rollover color flag.
`int`
`getSaturation()`
Get the selected colors saturation
`Icon`
`getSmallDisplayIcon()`
`Color`
`getSystemColor(String temp)`
Get the named system color
`void`
`installChooserPanel(JColorChooser enclosingChooser)`
`void`
`mouseClicked(MouseEvent e)`
Invoked when the mouse button has been clicked (pressed and released) on a component.
`void`
`mouseDragged(MouseEvent e)`
Invoked when the mouse exits a component.
`void`
`mouseEntered(MouseEvent e)`
Invoked when the mouse enters a component.
`void`
`mouseExited(MouseEvent e)`
Invoked when the mouse exits a component.
`void`
`mouseMoved(MouseEvent e)`
Invoked when the mouse exits a component.
`void`
`mousePressed(MouseEvent e)`
Invoked when a mouse button has been pressed on a component.
`void`
`mouseReleased(MouseEvent e)`
Invoked when a mouse button has been released on a component.
`void`
`mouseWheelMoved(MouseWheelEvent e)`
Move the sliders in rsponse to the mouse wheel
`void`
`removeChangeListener(ChangeListener l)`
Remove a change listener
`void`
`resetColorWheel()`
Reset the brightness and saturation multipliers for the ColorWheel.
`void`
`setAdjustWheel(int state)`
Set the adjust color wheel flag.
`void`
`setColor(Color c)`
`void`
`setColorScheme(int scheme)`
Set the Itten color scheme to use
`void`
`setDisplayScheme(boolean disp)`
Set the display of the color scheme markers.
`void`
`setHue(int h)`
Set the selected hue
`static void`
`setLabelBundle(ResourceBundle labelBundle)`
`void`
`setRollover(boolean state)`
Set the adjust rollover color flag.
`void`
`setSelectedColors(ModelColor[] clrs)`
Set the reference to the selected colours for the colour scheme
`void`
`stateChanged(ChangeEvent e)`
Invoked when the target of the listener has changed its state.
`void`
`updateChooser()`
`boolean`
`useDecimalRGB()`
Has the user selected the use decimal rgb checkbox?
`boolean`
`useWebColors()`
Has the user selected the use web safe colors checkbox?

### Methods inherited from class javax.swing.colorchooser.AbstractColorChooserPanel

`getColorFromModel, getColorSelectionModel, getDisplayedMnemonicIndex, getMnemonic, isColorTransparencySelectionEnabled, paint, setColorTransparencySelectionEnabled, uninstallChooserPanel`

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### MONOCHROMATIC_SCHEME

public static final int MONOCHROMATIC_SCHEME

See Also:
  - Constant Field Values

### CONTRASTING_SCHEME

public static final int CONTRASTING_SCHEME

See Also:
  - Constant Field Values

### SOFT_CONTRAST_SCHEME

public static final int SOFT_CONTRAST_SCHEME

See Also:
  - Constant Field Values

### DOUBLE_CONTRAST_SCHEME

public static final int DOUBLE_CONTRAST_SCHEME

See Also:
  - Constant Field Values

### ANALOGIC_SCHEME

public static final int ANALOGIC_SCHEME

See Also:
  - Constant Field Values

### CTRL_ADJUST

public static final int CTRL_ADJUST

See Also:
  - Constant Field Values

### ALWAYS_ADJUST

public static final int ALWAYS_ADJUST

See Also:
  - Constant Field Values

### NEVER_ADJUST

public static final int NEVER_ADJUST

See Also:
  - Constant Field Values

### hueEdit

protected JTextField hueEdit

### satEdit

protected JTextField satEdit

### brightEdit

protected JTextField brightEdit

### baseColorEdit

protected JTextField baseColorEdit

### pickerImage

protected BufferedImage pickerImage

### imagePicker

protected org.pushingpixels.substance.internal.contrib.xoetrope.editor.color.ColorWheelPanel.ColorWheel imagePicker

### fixedPanel

protected JPanel fixedPanel

### resetBtn

protected JButton resetBtn

### brightnessSlider

protected JSlider brightnessSlider

### saturationSlider

protected JSlider saturationSlider

### baseColorLabel

protected JLabel baseColorLabel

### innerCircle

protected Ellipse2D innerCircle

### outerCircle

protected Ellipse2D outerCircle

### borderCircle

protected Ellipse2D borderCircle

### useWebColors

protected JCheckBox useWebColors

### decimalRGB

protected JCheckBox decimalRGB

### font9pt

protected Font font9pt

### chooserColor

protected ModelColor chooserColor

### selectedIttenColours

protected ModelColor[] selectedIttenColours

## Constructor Details

### ColorWheelPanel

public ColorWheelPanel()
Creates a new instance of ColorWheelPanel

## Method Details

### setSelectedColors

public void setSelectedColors(ModelColor[] clrs)
Set the reference to the selected colours for the colour scheme

Parameters:
  `clrs` - the colors

### addChangeListener

public void addChangeListener(ChangeListener l)
Add a listener for changes in the selected color

Parameters:
  `l` - the change listener to add

### removeChangeListener

public void removeChangeListener(ChangeListener l)
Remove a change listener

Parameters:
  `l` - the change listener to remove

### useDecimalRGB

public boolean useDecimalRGB()
Has the user selected the use decimal rgb checkbox?

Returns:
  true if decimal rgb values are to be shown

### useWebColors

public boolean useWebColors()
Has the user selected the use web safe colors checkbox?

Returns:
  true if only web safe colors are to be shown

### setDisplayScheme

public void setDisplayScheme(boolean disp)
Set the display of the color scheme markers.

Parameters:
  `disp` - true to display the color scheme markers.

### getHue

public int getHue()
Get the selected colors hue

Returns:
  the selected hue in the range 0-255

### setHue

public void setHue(int h)
Set the selected hue

Parameters:
  `h` - the selected hue in the range 0-255

### getSaturation

public int getSaturation()
Get the selected colors saturation

Returns:
  the selected saturation in the range 0-255

### getBrightness

public int getBrightness()
Get the selected colors brightness

Returns:
  the selected brightness in the range 0-255

### setColorScheme

public void setColorScheme(int scheme)
Set the Itten color scheme to use

Parameters:
  `scheme` -
  - -1 for no scheme display
  - 0 for a monchromatic color scheme: MONOCHROMATIC_SCHEME
  - 1 for a contrasting color scheme: CONTRASTING_SCHEME
  - 2 for a soft-contrasting color scheme: SOFT_CONTRAST_SCHEME
  - 3 for a double contrasting color scheme: DOUBLE_CONTRAST_SCHEME
  - 4 for a analogical color scheme: ANALOGIC_SCHEME

### setColor

public void setColor(Color c)

### getColor

public Color getColor()
Get the selected color

Returns:
  the color

### getChooserColour

public ModelColor getChooserColour()
Get the chooser color

Returns:
  the chooser color

### actionPerformed

public void actionPerformed(ActionEvent e)
Respond to action events for the edit fields

Specified by:
  `actionPerformed` in interface `ActionListener`

### mouseClicked

public void mouseClicked(MouseEvent e)
Invoked when the mouse button has been clicked (pressed and released) on a component.

Specified by:
  `mouseClicked` in interface `MouseListener`

### mousePressed

public void mousePressed(MouseEvent e)
Invoked when a mouse button has been pressed on a component.

Specified by:
  `mousePressed` in interface `MouseListener`

### mouseReleased

public void mouseReleased(MouseEvent e)
Invoked when a mouse button has been released on a component.

Specified by:
  `mouseReleased` in interface `MouseListener`

### mouseEntered

public void mouseEntered(MouseEvent e)
Invoked when the mouse enters a component.

Specified by:
  `mouseEntered` in interface `MouseListener`

### mouseExited

public void mouseExited(MouseEvent e)
Invoked when the mouse exits a component.

Specified by:
  `mouseExited` in interface `MouseListener`

### mouseMoved

public void mouseMoved(MouseEvent e)
Invoked when the mouse exits a component.

Specified by:
  `mouseMoved` in interface `MouseMotionListener`

### mouseWheelMoved

public void mouseWheelMoved(MouseWheelEvent e)
Move the sliders in rsponse to the mouse wheel

Specified by:
  `mouseWheelMoved` in interface `MouseWheelListener`

### mouseDragged

public void mouseDragged(MouseEvent e)
Invoked when the mouse exits a component.

Specified by:
  `mouseDragged` in interface `MouseMotionListener`

### stateChanged

public void stateChanged(ChangeEvent e)
Invoked when the target of the listener has changed its state.

Specified by:
  `stateChanged` in interface `ChangeListener`
Parameters:
  `e` - a ChangeEvent object

### buildChooser

protected void buildChooser()

Specified by:
  `buildChooser` in class `AbstractColorChooserPanel`

### getDisplayName

public String getDisplayName()

Specified by:
  `getDisplayName` in class `AbstractColorChooserPanel`

### getLargeDisplayIcon

public Icon getLargeDisplayIcon()

Specified by:
  `getLargeDisplayIcon` in class `AbstractColorChooserPanel`

### getSmallDisplayIcon

public Icon getSmallDisplayIcon()

Specified by:
  `getSmallDisplayIcon` in class `AbstractColorChooserPanel`

### getPreferredSize

public Dimension getPreferredSize()

Overrides:
  `getPreferredSize` in class `JComponent`

### updateChooser

public void updateChooser()

Specified by:
  `updateChooser` in class `AbstractColorChooserPanel`

### installChooserPanel

public void installChooserPanel(JColorChooser enclosingChooser)

Overrides:
  `installChooserPanel` in class `AbstractColorChooserPanel`

### setLabelBundle

public static void setLabelBundle(ResourceBundle labelBundle)

### getSystemColor

public Color getSystemColor(String temp)
Get the named system color

Parameters:
  `temp` - the color name
Returns:
  the color value or null if the name is not recognized

### getAdjustWheel

public int getAdjustWheel()
Get the adjust color wheel flag.

Returns:
  the adjustment mode

### setAdjustWheel

public void setAdjustWheel(int state)
Set the adjust color wheel flag.

Parameters:
  `state` - the color wheel's new adjustment mode ( CTRL_ADJUST | ALWAYS_ADJUST | NEVER_ADJUST );

### getRollover

public boolean getRollover()
Get the adjust rollover color flag.

Returns:
  the adjustment mode

### setRollover

public void setRollover(boolean state)
Set the adjust rollover color flag.

Parameters:
  `state` - the rollover's new adjustment mode ( true | false );

### resetColorWheel

public void resetColorWheel()
Reset the brightness and saturation multipliers for the ColorWheel.